var app = angular.module('ionicApp', ['ionic','pascalprecht.translate']).run(function($ionicPlatform,$location,$ionicViewSwitcher,$ionicPopup,$rootScope,$ionicLocal,$translate) {
 
 $ionicPlatform.ready(function() {
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {		
		cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
		cordova.plugins.Keyboard.disableScroll(true);
		navigator.splashscreen.hide();
    }
    if (window.StatusBar) {
		StatusBar.styleDefault();
    }
    
    $rootScope.conPool = [];
	$rootScope.initSuc = false;
	$rootScope.init_tab = 0;
	$rootScope.records = [];
	$rootScope.isDiscover = false;
	$rootScope.isConnect = false;
	$rootScope.scanfinish = false;
	$rootScope.bluetoothle_open = false;
	$rootScope.disUid = null;
	$rootScope.cloUid = null;
	$rootScope.scanTimer = null
	var set_init = $ionicLocal.getObject("mysetting");
	if($.isEmptyObject(set_init)){
		set_init = {"cycle":28,"period":5,"height":160};
		$ionicLocal.setObject("mysetting",set_init);
	}
	var bmi_init = $ionicLocal.getObject("bmi");
	if($.isEmptyObject(bmi_init)){
		bmi_init = {"height":165,"weight":50,"first":true};
		$ionicLocal.setObject("bmi",bmi_init);
	}
	$rootScope.$on("toindex",function(e,data){
		setTimeout(function(){
			$rootScope.$broadcast("loginSuc",{status:true});
		},100);	
	});
	
	db_Init($rootScope,function(){
		console.log("changed language");
		navigator.globalization.getPreferredLanguage(function(language) {
			console.log(language);
			$translate.use(language.value.toLowerCase()).then(function(res){
				if(res == "en"){
					$rootScope.record_icon_on = "  ion-record-on-en "
					$rootScope.record_icon_off = " ion-record-off-en ";
					$rootScope.healthy_icon_on = "  ion-healthy-on-en "
					$rootScope.healthy_icon_off = " ion-healthy-off-en ";
					$rootScope.cure_icon_on = "  ion-cure-on-en "
					$rootScope.cure_icon_off = " ion-cure-off-en ";
					$rootScope.setting_icon_on = "  ion-setting-on-en "
					$rootScope.setting_icon_off = " ion-setting-off-en ";
					change_language(0);
				}else if(res == "tw"){
					$rootScope.record_icon_on = "  ion-record-on-tw "
					$rootScope.record_icon_off = " ion-record-off-tw ";
					$rootScope.healthy_icon_on = "  ion-healthy-on-tw "
					$rootScope.healthy_icon_off = " ion-healthy-off-tw ";	
					$rootScope.cure_icon_on = "  ion-cure-on-tw "
					$rootScope.cure_icon_off = " ion-cure-off-tw ";
					$rootScope.setting_icon_on = "  ion-setting-on-tw "
					$rootScope.setting_icon_off = " ion-setting-off-tw ";
					change_language(1);
				}else{
					$rootScope.record_icon_on = "  ion-record-on "
					$rootScope.record_icon_off = " ion-record-off ";
					$rootScope.healthy_icon_on = "  ion-healthy-on "
					$rootScope.healthy_icon_off = " ion-healthy-off ";
					$rootScope.cure_icon_on = "  ion-cure-on "
					$rootScope.cure_icon_off = " ion-cure-off ";
					$rootScope.setting_icon_on = "  ion-setting-on "
					$rootScope.setting_icon_off = " ion-setting-off ";
				}
				
				$rootScope.init_tab = 1;
				console.log("sending initTabSuccess broadcast");
				$rootScope.$broadcast("initTabSuccess",{status:true});				
			},function(id){
				console.log(id);
			}); 
		}, null);
	},function(err){
		console.log(err);
	});
	
	
	$ionicPlatform.registerBackButtonAction(function (e) {
      e.preventDefault();
      function showConfirm() {
        var confirmPopup = $ionicPopup.confirm({
          title: '<strong>'+exit_title+'?</strong>',
          template: exit_body+'?',
          okText: btnok,
          cancelText: btncal
        });
        confirmPopup.then(function (res) {
          if (res) {
			var devices = $ionicLocal.getObject("devices");
			for(var i in devices){
				bluetoothleDisconnect(devices[i].uuid,function(res){});
			} 
            ionic.Platform.exitApp();
          } else {
            // Don't close
          }
        });
      }
	  //根据路径不同，控制手机后退键不同动作
      if($location.path() == '/tab/record'||$location.path() == '/tab/healthy'||$location.path() == '/tab/cure'||$location.path() == '/tab/setting' || $location.path() == '/index') {
        if(angular.element("div.my-scrollerrange").length != 0){
			angular.element("div.my-scrollerrange").find("div.mbsc-fr-overlay").trigger("click");
		}else{
			showConfirm();
		}
      }else{
		if(angular.element("div.my-scrollerrange").length != 0){
			angular.element("div.my-scrollerrange").find("div.mbsc-fr-overlay").trigger("click");
		}else{
			history.go(-1);
			$ionicViewSwitcher.nextDirection("back");
		}
      }
      return false;
    }, 101);
	
	
	$rootScope.checkboxChange = function(e){
		var obj = $(e.target);
		if($(e.target).find("i").length!=0) obj = $(e.target).find("i");
		if(obj.hasClass("off")){
			obj.attr("class","ion-android-checkbox-outline on");
		}else if(obj.hasClass("on")){
			obj.attr("class","ion-android-checkbox-outline-blank off");
		}
	}
	$rootScope.globalGoBack = function(){
		history.go(-1);
		$ionicViewSwitcher.nextDirection("back");
	}
	

	//$rootScope.deviceIcon = "device_off";
	
  });
})
.config(function($stateProvider, $urlRouterProvider,$ionicConfigProvider,$translateProvider) {
	$ionicConfigProvider.tabs.position("bottom").style("standard");
	$ionicConfigProvider.backButton.previousTitleText(false).text("");
	$ionicConfigProvider.backButton.previousTitleText('').icon('icon ion-ios-arrow-back');
	$translateProvider.translations('en',language_en_gb);
	$translateProvider.translations('cn',language_zh_cn);
	$translateProvider.translations('tw',language_zh_tw);
	$translateProvider.registerAvailableLanguageKeys(['en','tw','cn'],{
		'en-*' : 'en',
		'zh-tw' : 'tw',
		'zh-mo' : 'tw',
		'zh-hk' : 'tw',
		'zh-cn' : 'cn'
	});
	//$translateProvider.use('cn');

  
  $stateProvider
    .state('tab', {
    url: '/tab',
    abstract: true,
    templateUrl: 'templates/tabs.html',
	controller: 'TabsCtrl'
  })
  .state('tab.record', {
	cache:true,
    url: '/record',
    views: {
      'tab-record': {
        templateUrl: 'templates/tab-record.html',
        controller: 'RecordCtrl'
      }
    }
  })
  .state('tab.healthy', {
	 cache:true,
      url: '/healthy',
      views: {
        'tab-healthy': {
          templateUrl: 'templates/tab-healthy.html',
          controller: 'HealthyCtrl'
        }
      }
    })
    .state('tab.cure', {
	  cache:true,
      url: '/cure',
      views: {
        'tab-cure': {
          templateUrl: 'templates/tab-cure.html',
          controller: 'CureCtrl'
        }
      }
    })
	.state('tab.device', {
	  cache:true,
      url: '/device/:uuid',
      views: {
        'tab-cure': {
          templateUrl: 'templates/device-view.html',
          controller: 'DeviceCtrl'
        }
      }
    })
  .state('tab.setting', {
	cache:true,
    url: '/setting',
    views: {
      'tab-setting': {
        templateUrl: 'templates/tab-setting.html',
        controller: 'SettingCtrl'
      }
    }
  })
  .state('tab.mysetting', {
	cache:true,
    url: '/mysetting',
    views: {
      'tab-setting': {
        templateUrl: 'templates/mysetting-view.html',
        controller: 'MySettingCtrl'
      }
    }
  })
   .state('tab.about', {
		cache:true,
		url: '/about',
		views: {
		  'tab-setting': {
			templateUrl: 'templates/about-view.html'
		  }
		} 
    })
	.state('tab.privpword', {
		cache:true,
		url: '/privpword/:type',
		views: {
		  'tab-setting': {
			templateUrl: 'templates/privpword-view.html',
			controller: 'PrivpwordCtrl'
		  }
		} 
    })
	.state('index', {
		cache:true,
		url: '/index',
		templateUrl: 'templates/index.html',
		controller: 'IndexCtrl'
    });
	var password = window.localStorage.getItem("password");
	var url = "/tab/record";
	/*if(!$.isEmptyObject(password)){
		url = "/index";
	}*/
	$urlRouterProvider.otherwise(url);
});
/*.directive("hideTabs",function($rootScope){
	return {
		restrict:"AE",
		link:function($scope){
			$rootScope.hideTabs = "tabs-item-hide";
			$scope.$on("$destroy",function(){
				$rootScope.hideTabs = "";
			});
		}
	}
});*/


