app.factory("$ionicLocal",['$window',function($window){
	return {
		set:function(key,value){
			$window.localStorage[key] = value;
		},
		get:function(key,defaultValue){
			return $window.localStorage[key]||defaultValue;
		},
		setObject:function(key,value){
			$window.localStorage[key] = JSON.stringify(value);
		},
		getObject:function(key){
			return JSON.parse($window.localStorage[key]||'{}');
		},
		clear:function(){
			window.localStorage.clear();
		}
	}
}]);
app.factory("$globalFactory",function($ionicLoading,$rootScope,$ionicLocal){
	return {
		mobiscroll_one:function(obj_Id,values,title,subtitle,className,width,height,callback){
			var instance,mainValues = [];
			for(var i in values) mainValues.push({display:values[i],value:values[i]});
			instance = mobiscroll.scroller(obj_Id,{
				theme:"mobiscroll",
				display:"center",
				width:width,//500/280
				height:height,//70/35
				headerText:"<div class='scroll-header'>"+title+"</div><div class='scroll-subheader'>"+subtitle+"</div>",
				wheels:[
					[{
						circular:false,
						data:mainValues
					}]
				],
				minWidth:130,
				cssClass:className,
				cancelText:btn1,
				setText:btn2,
				onSet:function(event,index){
					callback(event);
				}
			});
			
		},
		mobiscroll_two:function(obj_Id,values1,values2,title,subtitle,className,width,height,callback){
			var instance,leftValues = [],rightValues = [];
			for(var i in values1) leftValues.push({display:values1[i],value:values1[i]});
			for(var i in values2) rightValues.push({display:values2[i],value:values2[i]});
			instance = mobiscroll.scroller(obj_Id,{
				theme:"mobiscroll",
				display:"center",
				headerText:"<div class='scroll-header'>"+title+"</div><div class='scroll-subheader'>"+subtitle+"</div>",
				width:width,//500/280
				height:height,//70/35
				rows:3,
				wheels:[
					[{
						circular:false,
						data:leftValues
					},{
						circular:false,
						data:rightValues
					}]
				],
				minWidth:130,
				cssClass:className,
				cancelText:btn1,
				setText:btn2,
				onSet:function(event,index){
					callback(event);
				}
			});
		},
		getArrayIntValue:function(min,max,unit){
			var arr = [];
			for(var i=min;i<(max+1);i++) arr.push(i+unit);
			return arr;
		},
		getArrayFloatValue:function(arrays,unit,need){
			var arr = [];
			for(var i in arrays){
				var val = arrays[i];
				if(need) val = zoom_need(val);
				arr.push("."+val+unit);
			}	
			return arr;
		},
		getDateValue:function(type,timestamp){
			var data = {},date = new Date();
			if(type=="TODAY"){
				data.year = date.getFullYear();
				data.month = date.getMonth() + 1;
				data.day = date.getDate();
				data.timestamp =  new Date(data.year+"-"+zoom_need(data.month)+"-"+zoom_need(data.day)).getTime();
			}else if(type == "NEXT"){		
				var time = new Date(timestamp);
				data.month = time.getMonth();
				data.year = time.getFullYear();
				data.day = 1;
				if (data.month< 11) {
					data.month++;
				} else {
					data.month = 0;
					data.year++;
				}
				data.timestamp =  new Date(data.year+"-"+zoom_need(++data.month)+"-"+zoom_need(data.day)).getTime();
			}else if(type == "PREV"){
				var time = new Date(timestamp);
				data.month = time.getMonth();
				data.year = time.getFullYear();
				data.day = 1;
				 if (data.month > 0) {
					data.month--;
				} else {
					data.month = 11;
					data.year--;
				}
				data.timestamp =  new Date(data.year+"-"+zoom_need(++data.month)+"-"+zoom_need(data.day)).getTime();
			}else if(type == "FL"){
				var time = new Date();
				data.fstr  = time.getFullYear()+"-"+zoom_need(time.getMonth()+1)+"-01";
				var nextTime = new Date(time.getFullYear()+"-"+zoom_need(time.getMonth()+2)+"-01") - 86400*1000;
				data.estr = new Date(nextTime).getFullYear() + "-"+zoom_need(new Date(nextTime).getMonth()+1)+"-"+new Date(nextTime).getDate();
				data.sdtemp = new Date(data.fstr).getTime();
				data.edtemp = nextTime;
			}
			return data;
		},
		createTable : function(db,sql){
			db.transaction(function(tx) {
				tx.executeSql(sql);
			});
		},
		select : function(db,sql,success,error){
			db.transaction(function(tx) {
				tx.executeSql(sql, [], function(tx, rs) {
					var arr = [];
					for(var i=0;i<rs.rows.length;i++){
						arr.push(rs.rows.item(i));
					}
					success(arr);
				}, function(tx, err) {
					error(err);
				});
			});
		},
		insertOrUpdate : function(db,sql,params,success,error){
			db.transaction(function(tx) {
				tx.executeSql(sql,params, function(tx, res) {
					success(res); 
				}, function(e) {
					error(e);
				});
			});
		},
		execute : function(db,sql,success,error){
			console.log(sql);
			db.transaction(function(tx) {
				tx.executeSql(sql, function(tx, res) {
					success(res); 
				}, function(e) {
					error(e);
				});
			});
		},
		toast : function(msg,second){
			$ionicLoading.show({ template:msg,noBackdrop:true,duration:second});
		},
		makeSendData:function(cmd,data){
			var send_data = "0xA0,"+cmd+","+data+",0x0D,0x0A,0x00";
			return send_data;
		},
		getConDev : function(uuid){
			var device = {};
			for(var i in $rootScope.conPool){
				if($rootScope.conPool[i].uuid == uuid) {
					device = $rootScope.conPool[i];
					break;
				}
			}
			return device;
		},
		saveConDev : function(uuid,val,init){
			var length = 0;
			for(var i in $rootScope.conPool){
				if($rootScope.conPool[i].uuid == uuid){
					if(init) $rootScope.conPool[i] = val;
					continue;
				}
				length ++;
			}
			if(length == $rootScope.conPool.length){
				$rootScope.conPool.push(val);
			}
		},
		delConDev : function(uuid){
			for(var i in $rootScope.conPool){
				if($rootScope.conPool[i].uuid == uuid) {
					$rootScope.conPool.splice(i,1);
					break;
				}
			}
		}
	}
});

function caculateMensesDate(date,period){
	var sdtemp = new Date(date).getTime();
	var edtemp = sdtemp + 86400*(period-1)*1000;
	return  {"sdtemp":sdtemp,"edtemp":edtemp,"sdstr":getDateStr(sdtemp),"edstr":getDateStr(edtemp),"range":Number(period)};
}
function caculateEasyPregnancy(date,cycle){
	var sdtemp = new Date(date).getTime();
	var sdiff = cycle - 18;
	if(sdiff >= 2){
		var ep_sdtemp = sdtemp + 86400*(sdiff-1)*1000;
		var ep_edtemp = sdtemp + 86400*(cycle - 10)*1000;			
	}else{
		var ep_sdtemp = sdtemp + 86400*(sdiff-1)*1000;
		var ep_edtemp = ep_sdtemp + 86400*9*1000;					
	}
	var range = Math.floor((ep_edtemp-ep_sdtemp)/86400/1000);
	return {"sdtemp":ep_sdtemp,"edtemp":ep_edtemp,"sdstr":getDateStr(ep_sdtemp),"edstr":getDateStr(ep_edtemp),"range":range};
}
function caculateNextEasyPregnancy(ep_edtemp,days){
	var ep_sdtemp = ep_edtemp + days * 86400 * 1000;
	var ep_edtemp = ep_sdtemp + 86400*9*1000;		
	return {"sdtemp":ep_sdtemp,"edtemp":ep_edtemp,"sdstr":getDateStr(ep_sdtemp),"edstr":getDateStr(ep_edtemp),"range":10};
}
function caculateOvulate(ep_sdtemp){
	var ov_dtemp = ep_sdtemp + 86400*5*1000;			
	return  {"dtemp":ov_dtemp,"dstr":getDateStr(ov_dtemp)};
}
function caculatePredictivePeriod(date,cycle,period){
	var sdtemp = new Date(date).getTime();
	var sdiff = cycle - 18;
	if(sdiff >= 2){
		var pp_sdtemp = sdtemp + 86400*cycle*1000;		
		var pp_edtemp = pp_sdtemp + 86400*(sdiff-2)*1000;	
		var range = sdiff-2;
		if((sdiff - 2) > period)  {pp_edtemp = pp_sdtemp + 86400*(period-1)*1000;	range = period;}	
	}else{
		var pp_sdtemp  = 0;
		var pp_edtemp = 0;
		var range = 0;
	}
	return  {"sdtemp":pp_sdtemp,"edtemp":pp_edtemp,"sdstr":getDateStr(pp_sdtemp),"edstr":getDateStr(pp_edtemp),"range":range};
}



function getDateStr(timestamp){
	var time = new Date(timestamp);
	if(timestamp == "") time = new Date();
	return time.getFullYear()+"-"+zoom_need((time.getMonth()+1))+"-"+zoom_need(time.getDate());
}
function zoom_need(num){
	var returnStr = num;
	if(num < 10) returnStr = "0"+num;
	return returnStr;
}
function db_Init($rootScope,success,error){
	//数据库初始化---必须进行初始化
	var db = window.sqlitePlugin.openDatabase({name : DB_Name, location: DB_Location});
	db.transaction(function(tx) {
		tx.executeSql(CREATE_RECORD_TABLE);
	},function(err){
		console.log(JSON.stringify(err));
		error(err);
	},function(){
		$rootScope.db = db;
		console.log("open db ok");
		success();
	});
}
function bluetoothleInit($rootScope,success,error){
	//蓝牙初始化---必须进行初始化
	$rootScope.bluetoothle_open = false;
	window.bluetoothle.initialize(function(res){ success(res); }, false);
}
function bluetoothleIsEnable(success){
	window.bluetoothle.isEnabled(function(res){
		success(res);
	});
}

function bluetoothleOpen(success){
	window.bluetoothle.enable(function(res){
		success(res);
	},function(err){
		bluetoothleError(err);
	});
}

function bluetoothleStartScan(success){
	var sdk = device.apilevel;
	if(sdk >= Android6_Level){
		window.bluetoothle.hasPermission(function(res){
			if(!res.hasPermission){
				window.bluetoothle.requestPermission(function(res){
					if(res.requestPermission){
						requestLocationAndScan(success);
					}
				},function(err){console.log(JSON.stringify(err));});
			}else{
				requestLocationAndScan(success);
			}
		});

	}else{
		window.bluetoothle.startScan(function(res){
			success(res);
		},function(err){
			bluetoothleError(err);
		});
	}
}
function requestLocationAndScan(success){
	window.bluetoothle.isLocationEnabled(function(res){
		if(!res.isLocationEnabled){
			window.bluetoothle.requestLocation(function(res){
				if(res.requestLocation){
					window.bluetoothle.startScan(function(res){
						success(res);
					},function(err){
						bluetoothleError(err);
					});
				}
			},function(err){console.log(JSON.stringify(err));});
		}else{
			window.bluetoothle.startScan(function(res){
				success(res);
			},function(err){
				bluetoothleError(err);
			});
		}
		
	},function(err){console.log(JSON.stringify(err));});
}


function bluetoothleStopScan(){
	window.bluetoothle.stopScan(function(res){
		console.log(res);
		//alert(JSON.stringify(res));
	},function(err){
		console.log(err);
	});	
}
function bluetoothleConnect(uuid,success,error){
	window.bluetoothle.connect(function(res){
		success(res);
	},function(err){
		error(err);
	},{"address":uuid});	
}
function bluetoothleReConnect(uuid,success,error){
	window.bluetoothle.reconnect(function(res){
		success(res);
	},function(err){
		error(err);
	},{"address":uuid});	
}

function bluetoothleClose(uuid,success){
	window.bluetoothle.close(function(res){
		success(res);
	},function(err){
		bluetoothleError(err);
	},{"address":uuid});	
}

function bluetoothleDisconnect(uuid,success){
	window.bluetoothle.disconnect(function(res){
		success(res);
	},function(err){
		bluetoothleError(err);
	},{"address":uuid});	
}

function bluetoothleIsConnected(uuid,success,error){
	window.bluetoothle.isConnected(function(res){
		success(res);
	},function(err){
		error(err);
	},{"address":uuid});	
}



function bluetoothleDiscover(uuid,success,error){
	window.bluetoothle.discover(function(res){
		success(res);
	},function(err){
		error(err);
	},{"address":uuid});	
}
function bluetoothleWrite(address,service,characteristic,value,type,success){
	var params = {
		"address":address,
		"service":service,
		"characteristic":characteristic,
		"value":value,
		"type":type
	};
	window.bluetoothle.write(function(res){
		success(res);
	}, function(err){
		bluetoothleError(err);
	}, params);
}
function bluetoothleSubscribe(address,service,characteristic,success){
	var params = {
		"address":address,
		"service":service,
		"characteristic":characteristic
	};
	window.bluetoothle.subscribe(function(res){
		success(res);
	}, function(err){
		bluetoothleError(err);
	}, params);
}
function bluetoothleUnSubscribe(address,service,characteristic,success){
	var params = {
		"address":address,
		"service":service,
		"characteristic":characteristic
	};
	window.bluetoothle.unsubscribe(function(res){
		success(res);
	}, function(err){
		bluetoothleError(err);
	}, params);
}




function bluetoothleError(err){
	console.log(JSON.stringify(err));
}




function bluetoothleScanResult($rootScope){
	$rootScope.devices = [];
	$rootScope.scanfinish = false;
	bluetoothleStartScan(function(res){	
		if(res.status.trim() == BULETOOTH_SCAN_RESULT) {	
			var isEqual = false;
			for(var i in $rootScope.devices){
				if($rootScope.devices[i].uuid == res.address.trim()) {isEqual = true;break;}					
			}
			if(!isEqual){
				$rootScope.devices.push({uuid:res.address.trim(),name:res.name.trim()});	
			}				
		} 
	});
	setTimeout(function(){
		$rootScope.scanfinish = true;
		$rootScope.$broadcast("scanFinish",{status:true});
		bluetoothleStopScan();
	},3000);
}

function bluetoothleScan($rootScope){
	var scanDev = [];
	bluetoothleStartScan(function(res){	
		if(res.status.trim() == BULETOOTH_SCAN_RESULT) {	
			var isEqual = false;
			for(var i in scanDev){
				if(scanDev[i].uuid == res.address.trim()) {isEqual = true;break;}					
			}
			if(!isEqual){
				scanDev.push({uuid:res.address.trim(),name:res.name.trim()});	
			}				
		} 
	});
	setTimeout(function(){
		$rootScope.$broadcast("autoScan",{status:true,data:scanDev});
		bluetoothleStopScan();
	},3000);
}
