(function ($) {

    var eCalendar = function (options, object) {
        // Initializing global variables
		
		var settings = $.extend({}, $.fn.eCalendar.defaults, options);
		settings.weekDays = week;
		var cycle = settings.cycle;
		var period = settings.period;
		var firstTime = settings.firstTime;
		var checkTime = settings.checkTime;
		var epTime = settings.epTime;
        var adDay = settings.date.getDate();
        var adMonth = settings.date.getMonth();
        var adYear = settings.date.getFullYear();
		var events = settings.events;
        var dDay = adDay;
        var dMonth = adMonth;
        var dYear = adYear;
        var instance = object;

        function lpad(value, length, pad) {
            if (typeof pad == 'undefined') {
                pad = '0';
            }
            var p;
            for (var i = 0; i < length; i++) {
                p += pad;
            }
            return (p + value).slice(-length);
        }

		
        var nextMonth = function () {
            if (dMonth < 11) {
                dMonth++;
            } else {
                dMonth = 0;
                dYear++;
            }
        //    print();
        };
        var previousMonth = function () {
            if (dMonth > 0) {
                dMonth--;
            } else {
                dMonth = 11;
                dYear--;
            }
        //    print();
        };
		
	
	
        var print = function() {
            var dWeekDayOfMonthStart = new Date(dYear, dMonth, 1).getDay() - settings.firstDayOfWeek;
            if (dWeekDayOfMonthStart < 0) {
                dWeekDayOfMonthStart = 6 - ((dWeekDayOfMonthStart + 1) * -1);
            }
            var dLastDayOfMonth = new Date(dYear, dMonth + 1, 0).getDate();
            var dLastDayOfPreviousMonth = new Date(dYear, dMonth, 0).getDate() - dWeekDayOfMonthStart + 1;
            var cBody = $('<div/>').addClass('c-grid');
            var dayOfWeek = settings.firstDayOfWeek;
            for (var i = 0; i < 7; i++) {
                if (dayOfWeek > 6) {
                    dayOfWeek = 0;
                }
                var cWeekDay = $('<div/>').addClass('c-week-day');
				if(i == 0 || i == 6) cWeekDay.addClass('c-weekken-day');
                cWeekDay.html(settings.weekDays[dayOfWeek]);
                cBody.append(cWeekDay);
                dayOfWeek++;
            }
            var day = 1;
            var dayOfNextMonth = 1;
            for (var i = 0; i < 42; i++) {
                var cDay = $('<div/>');
                if (i < dWeekDayOfMonthStart) {
                    cDay.addClass('c-day-previous-month c-pad-top c-day-border');
                    cDay.html(dLastDayOfPreviousMonth++);
                } else if (day <= dLastDayOfMonth) {
					var today = new Date();
                    cDay.addClass('c-day c-pad-top c-day-border ');
					var temp_str = adYear+"-"+lpad((adMonth+1),2)+"-"+ lpad(day,2);
					
					var temp = new Date(temp_str).getTime();
					if(temp == new Date(today.getFullYear()+"-"+lpad((today.getMonth()+1),2)+"-"+ lpad(today.getDate(),2)).getTime()) cDay.addClass("c-day-today");
					
					cDay.html(day++).off("click").on("click",dayTap).attr("date-val",temp_str).attr("date-temp",temp);
					if(firstTime.length!=0){
						if(firstTime[0] <= temp && temp <= firstTime[1] && firstTime[2]) cDay.addClass("menses-range");	
						if(firstTime[0] <= temp && temp <= firstTime[1] && !firstTime[2]) cDay.addClass("pp-range");	
						if(temp == firstTime[0]  && firstTime[2]) cDay.addClass("menses-range-s").append($("<img class='rel-img mrs rem' src='./img/record_calendar_tile_coming@2x.png'/>"));
						if(temp == firstTime[1] && firstTime[2]) cDay.addClass("menses-range-e").append($("<img class='rel-img mre rem' src='./img/record_calendar_tile_gone@2x.png'/>"));						
					}
					if(checkTime.length!=0){
							if(checkTime[0] <= temp && temp <= checkTime[1]) cDay.addClass("pp-range");
					}
					if(epTime.length!=0){
						for(var x=0;x<epTime.length;x ++){
							if(epTime[x] !=0 && temp >= epTime[x] && temp <= epTime[++x]) {
								cDay.addClass("ep-range");
							}
						}
						var  ovulate = caculateOvulate(epTime[0]);	
						if(temp == ovulate.dtemp) cDay.addClass("ovulate-day").append($("<img class='rel-img od rem' src='./img/record_calendar_tile_ovulate@2x.png'/>"));							
					}
					for(var y in events){
						var obj = events[y];
						if(temp == obj.id){
							var div = $("<div class='rem-div'/>");
							var div2 =  $("<div class='rem-sdiv'/>");
							if(obj.diary != null || obj.emotion != -1){
								if(div.find("img").length ==3) {
									div2.append($("<img class='rer-img diary ' src='./img/record_calendar_tile_diary@2x.png'>"));
								}else{
									div.append($("<img class='rer-img diary ' src='./img/record_calendar_tile_diary@2x.png'>"));
								}	
							}
							if(obj.habbit != null){
								if(div.find("img").length ==3) {
									div2.append($("<img class='rer-img habbit ' src='./img/record_calendar_tile_habbit@2x.png'>"));
								}else{
									div.append($("<img class='rer-img habbit ' src='./img/record_calendar_tile_habbit@2x.png'>"));
								}	
							}
							if(obj.love != null){
								if(div.find("img").length ==3) {
									div2.append($("<img class='rer-img love ' src='./img/record_calendar_tile_makelove@2x.png'>"));
								}else{
									div.append($("<img class='rer-img love ' src='./img/record_calendar_tile_makelove@2x.png'>"));
								}	
							}
							if(obj.weight != null || obj.temperature != null){
								if(div.find("img").length ==3) {
									div2.append($("<img class='rer-img record ' src='./img/record_calendar_tile_record@2x.png'>"));
								}else{
									div.append($("<img class='rer-img record ' src='./img/record_calendar_tile_record@2x.png'>"));
								}	
							}
							if(obj.symptom != null){
								if(div.find("img").length ==3) {
									div2.append($("<img class='rer-img symptom ' src='./img/record_calendar_tile_bloord@2x.png'>"));
								}else{
									div.append($("<img class='rer-img symptom ' src='./img/record_calendar_tile_bloord@2x.png'>"));
								}	
							}
							cDay.append(div).append(div2);
							break;
						}
					}
					
			   } else {
                    cDay.addClass('c-day-next-month c-pad-top c-day-border');
                    cDay.html(dayOfNextMonth++);
                }
                cBody.append(cDay);
            }
			$(instance).html(cBody);
        }
		function dayTap(){
			settings.callBack(this);
		}

        return  print();
    }
		
	


	
    $.fn.eCalendar = function (oInit) {
        return this.each(function () {
            return eCalendar(oInit, $(this));
        });
    };
	

	
	
	

	
	
	
	
	
	
	
    // plugin defaults
    $.fn.eCalendar.defaults = {
        months: ['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
        events: [],
		date: new Date(),
		firstTime:[],
		checkTime:[],
		epTime:[],
		cycle:0,
		period:0,
        firstDayOfWeek: 0,
		callBack:function(res){}
    };
}(jQuery));